<?php

namespace FiloBlu\AdminSecurity\Plugin\Block\User\Edit;

use FiloBlu\AdminSecurity\Helper\Data;
use Magento\Framework\AuthorizationInterface;
use Magento\User\Block\User\Edit\Tabs;

class TabsPlugin
{
    /**
     * @var Data
     */
    private $helper;

    /**
     * @var AuthorizationInterface
     */
    private $authorization;

    /**
     * TabsPlugin constructor.
     * @param Data $helper
     * @param AuthorizationInterface $authorization
     */
    public function __construct(
        Data $helper,
        AuthorizationInterface $authorization
    ) {
        $this->helper = $helper;
        $this->authorization = $authorization;
    }

    /**
     * @param Tabs $subject
     * @throws \Magento\Framework\Exception\LocalizedException
     */
    public function beforeToHtml(Tabs $subject)
    {
        if (!$this->helper->adminSecurityIsEnabled() ||
            !$this->authorization->isAllowed('FiloBlu_AdminSecurity::tfa')
        ) {
            return;
        }

        $tfaForm = $subject->getLayout()->renderElement('filobluas_twofactorauth_edit_user_form');

        $subject->addTabAfter(
            'filobluas_twofactorauth',
            [
                'label' => __('FiloBlu 2FA'),
                'title' => __('FiloBlu 2FA'),
                'content' => $tfaForm,
                'active' => true
            ],
            'roles_section'
        );
    }
}
